source: trunk/debathena/scripts/dasource @ 23440

Revision 23440, 3.2 KB checked in by tabbott, 15 years ago (diff)
dasource: Use the daorig in $basedir, not PATH.
  • Property svn:executable set to *
RevLine 
[22704]1#!/bin/sh
2
3# Usage: dasource [-r REPOS] [PACKAGENAME ...]
4
5# Creates or updates a checkout and source package for each listed
6# PACKAGENAME, or for all regular packages if no PACKAGENAME is
7# specified.
8
9# If REPOS is specified, it is used in preference to the canonical
10# Athena repository trunk.
11
12# Package subdirectories are created in the cwd.  The source checkout
13# will reside in PACKAGENAME/PACKAGENAME-VERSION and the source
14# package will be created in PACKAGENAME.
15
16set -e
17
[22742]18die() {
19  echo "$@" >&2
20  exit 1
21}
22
23usage() {
24  die "dasource [-r repos] [packagename ...]"
25}
26
[22720]27: ${DEBATHENA_APT=/mit/debathena/apt}
28basedir=$(dirname "$0")
[22704]29repo=svn+ssh://svn.mit.edu/athena/trunk
30
31while getopts r: opt; do
32  case "$opt" in
33  r)
34    type="$OPTARG"
35    ;;
36  \?)
[22742]37    usage
[22704]38    ;;
39  esac
40done
41
42do_package() {
43  pkgname=$1
44  pkgpath=$2
45  if [ ! -d $pkgname ]; then
46    echo "Creating directory $pkgname"
47    mkdir $pkgname
48  fi
[22706]49
[23064]50  # Work around a bad interaction between dpkg-source and AFS.
51  # (dpkg-source invokes perl's Tempfile which checks if the parent
52  # directory is writable using mode bits).  This will not actually
53  # grant any outside access to the directory since AFS ignores
54  # non-user mode bits.
55  if fs whichcell . >/dev/null 2>&1; then
56    chmod 777 $pkgname
57  fi
58
[22706]59  # Check out or update the package source.
[22767]60  pattern="$pkgname/$pkgname-[0-9]*[0-9]"
61  if [ $(echo $pattern | wc -w) -gt 1 ]; then
[22704]62    die "More than one checkout under $pkgname!"
[22767]63  elif [ -d $pattern ]; then
64    dir=$(echo $pattern)
[22712]65    echo "Updating and cleaning $dir"
66    (cd $dir && svn update && svn revert -R . &&
67     svn st | awk '/^?/ {print $2}' | xargs rm -vrf)
[22704]68  else
69    dir=$pkgname/$pkgname
70    echo "Checking out $repo/$pkgpath into $dir"
71    svn co $repo/$pkgpath $dir
72  fi
[22706]73
74  # Extract the changelog version and strip off the epoch and Debian component.
[22704]75  changever=$(cd $dir && dpkg-parsechangelog | sed -n 's/Version: //p')
[22706]76  sver=$(echo $changever | sed -re 's/^[0-9]+://p')
77  upver=$(echo $sver | sed -re 's/-[^-]*$//')
78
79  # Rename the source checkout if necessary.
[22704]80  correctdir=$pkgname/${pkgname}-$upver
81  if [ $dir != $correctdir ]; then
82    echo "Renaming $dir to $correctdir"
83    mv $dir $correctdir
84    dir=$correctdir
85  fi
[22706]86
[22720]87  # Add autoconf goo if it's an Athena source directory.
88  case $pkgpath in
89  athena/*)
90    (cd $dir && $basedir/daconfiscate)
91    ;;
92  esac
93
[23407]94  # Generate debian/control from debian/control.in if control.in exists
95  ([-f "$dir/debian/control.in"] && cd $dir && DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes debian/rules debian/control)
[23290]96
[22786]97  # Create a suitable orig tarball if necessary.
[23440]98  (cd $dir && $basedir/daorig)
[22706]99
100  # Build an unsigned package, ignoring version control subdirs in the source.
[22704]101  echo "Creating source package"
[22766]102  (cd $dir && debuild -S -i -I.svn -sa -us -uc)
[22704]103}
104
[22745]105if [ ! -r packages ]; then
106  die "Can't read packages file; create with gen-packages"
107fi
108
[22704]109if [ $# -gt 0 ]; then
110  # Build specific source packages.
111  for pkgname; do
[22745]112    pkgpath=$(sed -nre "s/^$pkgname[[:space:]]+//p" packages)
[22704]113    [ -n "$pkgpath" ] || die "Can't find package $pkgname"
114    do_package $pkgname $pkgpath
115  done
116else
117  # Build all source packages.
[22745]118  exec <packages
[22704]119  while read pkgname pkgpath; do
120    do_package $pkgname $pkgpath
121  done
122fi
Note: See TracBrowser for help on using the repository browser.